<template>
  <div class='order-card-body__sidebar'>
    <div
        v-if="orderCondition"
        class="order-card-body__sidebar-condition -gray-slate"
    >
      <i
          :class="orderCondition.icon"
          class="icon"
      />
      {{ orderCondition.text }}
    </div>
    <div class='order-card-body__contacts'>
      <div class='order-card-body__contact'>
        <p class='order-card-body__contact-label'>Заказчик</p>
        <p class='order-card-body__contact-info'>
          <i class='icon' :class="iconByRole(order.clientRoleCode)"/>
          <span class="-max210">{{ order.clientTitle }}</span>
        </p>
      </div>

      <div class='order-card-body__contact'>
        <p class='order-card-body__contact-label'>Контактное лицо</p>
        <p class='order-card-body__contact-info'>
          <i class='icon visitcard'></i>
          {{ order.clientLogistTitle }}
        </p>
      </div>

      <div class='order-card-body__contact'>
        <p class='order-card-body__contact-label'>Исполнитель</p>
        <p class='order-card-body__contact-info'>
          <i class='icon' :class="iconByRole(order.contractorRoleCode)"></i>
          {{ order.contractorTitle }}
        </p>
      </div>

      <div class='order-card-body__contact'>
        <p class='order-card-body__contact-label'>Ответственный менеджер</p>
        <p class='order-card-body__contact-info'>
          <i class='icon visitcard'></i>
          {{ order.logistTitle }}
        </p>
      </div>
    </div>

    <div class='order-card-body__price'>
      <p>Стоимость</p>
      <div class="add-services">
        <button
            class="add-services__button"
            @click="isShowBaseServices = !isShowBaseServices"
        >
          <i
              class="icon"
              :class="isShowBaseServices ? 'chevron-up' : 'chevron-down'"
          />
          <span>Услуги по перевозке</span>
          <span>{{ (baseServiceWithExtra / 100 ) | currency({ dot: 2 }) }} ₽</span>
        </button>
        <ExpandTransition>
          <div
              v-if="isShowBaseServices"
              class="add-services__list"
          >
            <div class="add-services__item">
              <span>Базовая услуга</span>
              <span>{{ ((order.orderCost ? order.orderCost.priceWithVat : order.tripTariff) / 100 ) | currency({ dot: 2 }) }} ₽</span>
            </div>

            <div
              v-if="order.isSuborder"
              class="add-services__item"
            >
              <span>Итого допробег</span>
              <span v-if="extraDistance">{{ (extraDistance.price / 100 ) | currency({ dot: 2 }) }} ₽</span>
              <span v-else>0 ₽</span>
            </div>

            <div
              v-if="order.isSuborder"
              class="add-services__item"
            >
              <span>Итого допточки</span>
              <span v-if="extraPoints">{{ (extraPoints.price / 100 ) | currency({ dot: 2 }) }} ₽</span>
              <span v-else>0 ₽</span>
            </div>
          </div>
        </ExpandTransition>
      </div>


      <div
          v-if="order.addServicesSumm"
          class="add-services"
      >
        <button
            class="add-services__button"
            @click="showAddServices"
        >
          <i
              class="icon"
              :class="isShowAddServices ? 'chevron-up' : 'chevron-down'"
          />
          <span>Дополнительные услуги</span>
          <span>{{ (order.addServicesSumm / 100 ) | currency({ dot: 2 }) }} ₽</span>
        </button>
        <ExpandTransition>
          <div
              v-if="isShowAddServices"
              class="add-services__list"
          >
            <div
                v-for="(item, index) in order.addServicesList"
                :key="item.title + '-' + item.price + '-' + index"
                class="add-services__item"
            >
              <span :title="item.title">{{ item.title }}</span>
              <span>{{ (item.price / 100 ) | currency({ dot: 2 }) }} ₽</span>
            </div>
          </div>
        </ExpandTransition>
      </div>

      <div class='order-card-body__total-price'>
        <p>
          {{ order.vatType !== 'NO_VAT' ? 'Итого' : 'Итого без НДС' }}
          <span>{{ (order.totalPriceWithVat / 100 ) | currency({ dot: 2 }) }} ₽</span>
        </p>
        <template v-if="order.vatType !== 'NO_VAT'">
          <p>
            Итого без НДС
            <span>{{ (order.totalPriceWithoutVat / 100 ) | currency({ dot: 2 }) }} ₽</span>
          </p>
          <p>
            НДС
            <span>{{ (order.vatValue / 100 ) | currency({ dot: 2 }) }} ₽</span>
          </p>
        </template>
      </div>
      <AdvanceButton
          :order="order"
      />
    </div>
  </div>
</template>
<script>
  import { mapGetters } from 'vuex'
  import { iconByRole } from '@/helpers/user'
  import AdvanceButton from '@/components/Order/orderItem/advance/button'
  import ExpandTransition from 'common-components/src/obComponents/obExpandTransition';

  export default {
    name: 'OrderCardRightSide',
    components: {
      AdvanceButton,
      ExpandTransition
    },
    props: {
      order: {
        type: Object,
        default: () => {}
      },
      isShowAdvance: {
        type: Boolean,
        default: true
      }
    },
    data () {
      return {
        isShowBaseServices: false,
        isShowAddServices: false
      }
    },
    computed: {
      ...mapGetters({
        isCarrier: 'user/isCarrier'
      }),
      orderCondition () {
        if (!this.order || !this.order.orderCondition) return

        if (this.order.orderCondition === 'QUOTA') return {
          icon: 'handshake',
          text: 'Квота'
        }

        if (this.order.orderCondition === 'SPOT') return {
          icon: 'hot-2 -light-raspberry-red',
          text: 'Спот'
        }

        return false
      },
      extraDistance () {
        return this.order.addMainServices?.services.find(key => key.serviceTypeCode === "EXTRA_DISTANCE")
      },
      extraPoints () {
        return this.order.addMainServices?.services.find(key => key.serviceTypeCode === "EXTRA_POINT")
      },
      baseServiceWithExtra () {
        return (this.order.orderCost ? this.order.orderCost.priceWithVat : this.order.tripTariff) +
          (this.extraDistance ? this.extraDistance.price : 0) + (this.extraPoints ? this.extraPoints.price : 0)
      }
    },
    methods: {
      iconByRole,
      showAddServices () {
        this.isShowAddServices = !this.isShowAddServices
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .order-card-body {
    &__sidebar {
      z-index: 20;
      flex-shrink: 0;
      width: 338px;
      box-shadow: 0px 2px 10px rgba($color-blue-navy-blue, 0.15);

      .add-services {
        padding-bottom: 25px;
        &__button {
          position: relative;
          display: flex;
          width: 100%;
          justify-content: space-between;
          background-color: transparent;
          border: none;
          outline: none;
          cursor: pointer;
          &:hover {
            opacity: 0.8;
          }
          i {
            position: absolute;
            top: 0;
            left: -20px;
            color: $color-blue-navy-blue;
          }
          span {
            @include font-mixin(12px, 12px, 400, $color-text-base, 0.4px);
            &:last-child {
              font-weight: 700;
            }
          }
        }
        &__item {
          display: flex;
          justify-content: space-between;
          min-width: 0;
          margin-top: 10px;
          span {
            @include font-mixin(12px, 12px, 400, $color-grey-label, 0.4px);
            &:first-of-type {
              max-width: 100%;
              overflow: hidden;
              text-overflow: ellipsis;
              white-space: nowrap;
            }
            &:last-child {
              margin-left: 20px;
              flex-shrink: 0;
            }
          }
        }
      }
    }

    &__sidebar-condition {
      position: absolute;
      display: flex;
      align-items: center;
      top: 28px;
      right: 30px;
      font-size: 10px;

      .icon {
        margin-right: 4px;
        font-size: 16px;
        color: $color-blue-navy-blue;
      }
    }

    &__contacts {
      padding: 30px 30px 21px;
      border-bottom: 1px solid rgba($color-grey-border, 0.5);
    }

    &__contact {
      margin-bottom: 10px;
      &-label {
        @include font-mixin(10px, 12px, 400, $gray-slate, 0.4px);
      }
      &-info {
        display: flex;
        align-items: center;
        @include font-mixin(14px, 16px, 400, $gray-slate, 0.4px);

        .icon {
          margin-right: 3px;
          color: $color-blue-navy-blue;
        }

        .-max210 {
          max-width: 210px;
          white-space: nowrap;
          text-overflow: ellipsis;
          overflow: hidden;
        }
      }
    }

    &__price {
      padding: 25px 30px 30px;
      border-bottom: 1px solid rgba($color-grey-border, 0.5);
      p {
        font-weight: bold;
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.4px;
        margin-bottom: 10px;
      }
    }

    &__temp-price {
      padding-bottom: 21px;
      p {
        display: flex;
        justify-content: space-between;
        span {
          font-weight: 700;
        }
        @include font-mixin(12px, 12px, 400, $color-text-base, 0.4px);
      }

      p:first-child {
        margin-bottom: 10px;
        @include font-mixin(16px, 24px, 700, $color-text-base, 0.4px);
        span {
          font-weight: 700;
        }
      }
    }

    &__total-price {
      padding-top: 21px;
      border-top: 1px solid $color-grey-border;
      p {
        display: flex;
        justify-content: space-between;
        @include font-mixin(12px, 14px, 400, $gray-slate, 0.4px);
      }

      p:first-child {
        @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);
      }

      p + p {
        margin-top: 10px;
      }
    }
  }
</style>
